
if(WIN32)
	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(JDF_OUTPUT_WIN_NAME Win64)
	else()
		set(JDF_OUTPUT_WIN_NAME Win32)
	endif()
	if (MSVC11)
		set(JDF_MSVC_FOLDER VC11)
	elseif (MSVC10)
		set(JDF_MSVC_FOLDER VC10)
	elseif(MSVC90)
		set(JDF_MSVC_FOLDER VC9)
	elseif(MSVC80)
		set(JDF_MSVC_FOLDER VC8)
	else()
		message(SEND_ERROR "Unsupported MSVC version")
	endif()

	set(JDF_EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_LIST_DIR}/bin/${JDF_OUTPUT_WIN_NAME}/${JDF_MSVC_FOLDER})
	set(JDF_LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_LIST_DIR}/bin/${JDF_OUTPUT_WIN_NAME}/${JDF_MSVC_FOLDER})
	set(JDF_CMAKE_DEBUG_POSTFIX _D)
else()
	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(JDF_ARCH x64)
	else()
		set(JDF_ARCH x86)
	endif()
	if(APPLE)
		set(JDF_MAC_OR_LINUX Mac)
	else()
		set(JDF_MAC_OR_LINUX Linux)
	endif()
	set(JDF_EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_LIST_DIR}/bin/${JDF_MAC_OR_LINUX}/${JDF_ARCH})
	set(JDF_LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_LIST_DIR}/bin/${JDF_MAC_OR_LINUX}/${JDF_ARCH})
endif()
